<?php

namespace App;

use JetBrains\PhpStorm\ArrayShape;
use phpDocumentor\Reflection\Types\Void_;

class Adapter
{
    private $concrete = [
        'name'  => '',
        'short' => '',
        'obj'   => null
    ];

    private \ReflectionClass $reflection;

    private array $methods = [];

    public function __construct(
        private string $abstract,
        object         $concrete
    ) {
        $this->prepareConcrete($concrete);
        $this->reflection = new \ReflectionClass($this->abstract);
        $this->checkInterface();
    }

    private function prepareConcrete(object $concrete): void
    {
        $concreteClass = get_class($concrete);
        $exploded = explode('\\', $concreteClass);
        $this->concrete = [
            'name'  => '\\' . $concreteClass,
            'short' => end($exploded),
            'obj'   => $concrete
        ];
    }

    public function create()
    {
        foreach ($this->reflection->getMethods(\ReflectionMethod::IS_PUBLIC) as $method) {
            $this->methods[] = $this->createMethod($method);
        }
        return Container::instance()->make(
            $this->build(),
            ['obj' => $this->concrete['obj']]
        );

    }

    private function checkInterface(): void
    {
        if (!$this->reflection->isInterface()) {
            throw new \Exception('Abstract must be an interface');
        }
    }

    private function createMethod(\ReflectionMethod $method): string
    {
        $return = $method->getReturnType()->getName() === (new Void_())->__toString() ? '' : 'return';
        $args = [];
        foreach ($method->getParameters() as $parameter) {
            $args[] .= "'{$parameter->getName()}' => \${$parameter->getName()}";
        }
        ['name' => $name, 'type' => $type] = $this->parseFunction($method);


        return sprintf(
            'public function %s(%s): %s{%s \\App\\Container::instance()->make("%s.operations.%s:%s%s", ["obj" => $this->obj, "args" => %s]);}',
            $method->getName(),
            implode(',',
                array_map(
                    static fn(\ReflectionParameter $parameter) => ($parameter->getType()
                                                                             ?->isBuiltin() ? '' : '\\') . $parameter->getType() . " $" . $parameter->getName(),
                    $method->getParameters()
                )),
            ($method->getReturnType()?->isBuiltin() ? '' : '\\') . $method->getReturnType(),
            $return,
            $this->concrete['name'],
            $method->getDeclaringClass()->getName(),
            $name,
            $type ? ".$type" : '',
            '[' . implode(',', $args) . ']'
        );
    }

    #[ArrayShape(['name' => 'string', 'type' => 'string'])]
    private function parseFunction(\ReflectionMethod $method): array
    {
        $type = substr($method->getName(), 0, 3);
        $types = ['get', 'set', 'has'];
        if (in_array($type, $types, true)) {
            return [
                'name' => mb_strtolower(substr($method->getName(), 3)),
                'type' => $type
            ];
        }
        return [
            'type' => '',
            'name' => $method->getName()
        ];
    }


    private function build(): string
    {
        $namespace = "App\\AutoGenerated" . str_replace($this->reflection->getNamespaceName(), '', $this->reflection->getName());
        $code = sprintf(
            "<?php\nnamespace %s;\nclass %s implements \\%s{public function __construct(private %s \$obj){}%s}",
            $namespace,
            $this->concrete['short'],
            $this->reflection->getName(),
            $this->concrete['name'],
            implode("\n", $this->methods)
        );

        $dir = __DIR__ . '/' . str_replace(['App\\', '\\'], ['', '/'], $namespace);
        if (!file_exists($dir) && !mkdir($dir, 0777, true) && !is_dir($dir)) {
            throw new \RuntimeException(sprintf('Directory "%s" was not created', $dir));
        }

        file_put_contents(
            sprintf('%s/%s.php', $dir, $this->concrete['short']),
            $code
        );

        return "\\$namespace\\{$this->concrete['short']}";

    }

}